
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Message_recipientsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const message_recipients = await db.message_recipients.create(
            {
                id: data.id || undefined,
        
        recipient_type: data.recipient_type
        ||
        null
            ,
            
        recipient_label: data.recipient_label
        ||
        null
            ,
            
        destination: data.destination
        ||
        null
            ,
            
        delivery_status: data.delivery_status
        ||
        null
            ,
            
        delivered_at: data.delivered_at
        ||
        null
            ,
            
        read_at: data.read_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await message_recipients.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await message_recipients.setMessage( data.message || null, {
            transaction,
        });
        

        

        

        return message_recipients;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const message_recipientsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                recipient_type: item.recipient_type
            ||
            null
            ,
            
                recipient_label: item.recipient_label
            ||
            null
            ,
            
                destination: item.destination
            ||
            null
            ,
            
                delivery_status: item.delivery_status
            ||
            null
            ,
            
                delivered_at: item.delivered_at
            ||
            null
            ,
            
                read_at: item.read_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const message_recipients = await db.message_recipients.bulkCreate(message_recipientsData, { transaction });

        // For each item created, replace relation files
        

        return message_recipients;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const message_recipients = await db.message_recipients.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.recipient_type !== undefined) updatePayload.recipient_type = data.recipient_type;
        
        
        if (data.recipient_label !== undefined) updatePayload.recipient_label = data.recipient_label;
        
        
        if (data.destination !== undefined) updatePayload.destination = data.destination;
        
        
        if (data.delivery_status !== undefined) updatePayload.delivery_status = data.delivery_status;
        
        
        if (data.delivered_at !== undefined) updatePayload.delivered_at = data.delivered_at;
        
        
        if (data.read_at !== undefined) updatePayload.read_at = data.read_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await message_recipients.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await message_recipients.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.message !== undefined) {
            await message_recipients.setMessage(
              
              data.message,
              
              { transaction }
            );
        }
        

        
        

        

        return message_recipients;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const message_recipients = await db.message_recipients.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of message_recipients) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of message_recipients) {
                await record.destroy({transaction});
            }
        });


        return message_recipients;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const message_recipients = await db.message_recipients.findByPk(id, options);

        await message_recipients.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await message_recipients.destroy({
            transaction
        });

        return message_recipients;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const message_recipients = await db.message_recipients.findOne(
            { where },
            { transaction },
        );

        if (!message_recipients) {
            return message_recipients;
        }

        const output = message_recipients.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await message_recipients.getOrganization({
            transaction
        });
        
        
        output.message = await message_recipients.getMessage({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.messages,
        as: 'message',
        
        where: filter.message ? {
          [Op.or]: [
            { id: { [Op.in]: filter.message.split('|').map(term => Utils.uuid(term)) } },
            {
              subject: {
                [Op.or]: filter.message.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.recipient_label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'message_recipients',
                        'recipient_label',
                        filter.recipient_label,
                    ),
                };
            }
            
            if (filter.destination) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'message_recipients',
                        'destination',
                        filter.destination,
                    ),
                };
            }
            

            
            

            
            if (filter.delivered_atRange) {
                const [start, end] = filter.delivered_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    delivered_at: {
                    ...where.delivered_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.read_atRange) {
                const [start, end] = filter.read_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    read_at: {
                    ...where.read_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    read_at: {
                    ...where.read_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.recipient_type) {
                where = {
                    ...where,
                recipient_type: filter.recipient_type,
            };
            }
            
            if (filter.delivery_status) {
                where = {
                    ...where,
                delivery_status: filter.delivery_status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.message_recipients.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'message_recipients',
                        'recipient_label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.message_recipients.findAll({
            attributes: [ 'id', 'recipient_label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['recipient_label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.recipient_label,
        }));
    }

    
};

